gtkmm: Gtk::FileChooserDialog Class Reference

gtkmm 3.91.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gtk::FileChooserDialog Class Reference
Dialogs

Convenient file chooser window. More...

`#include <gtkmm/filechooserdialog.h>`

Inheritance diagram for Gtk::FileChooserDialog:
[legend]

## Public Member Functions
| FileChooserDialog (FileChooserDialog&& src) noexcept
FileChooserDialog& | operator= (FileChooserDialog&& src) noexcept
| FileChooserDialog (const FileChooserDialog&)=delete
FileChooserDialog& | operator= (const FileChooserDialog&)=delete
| ~FileChooserDialog () noexceptoverride
GtkFileChooserDialog* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkFileChooserDialog* | gobj () const
| Provides access to the underlying C GtkObject. More...
| FileChooserDialog (Gtk::Window& parent, const Glib::ustring& title, Action action=Action::OPEN, bool use_header_bar=false)
| FileChooserDialog (const Glib::ustring& title, Action action=Action::OPEN, bool use_header_bar=false)
Public Member Functions inherited from Gtk::Dialog
| Dialog (Dialog&& src) noexcept
Dialog& | operator= (Dialog&& src) noexcept
| Dialog (const Dialog&)=delete
Dialog& | operator= (const Dialog&)=delete
| ~Dialog () noexceptoverride
GtkDialog* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkDialog* | gobj () const
| Provides access to the underlying C GtkObject. More...
| Dialog ()
| Dialog (const Glib::ustring& title, bool modal=false, bool use_header_bar=false)
| Dialog (const Glib::ustring& title, Gtk::Window& parent, bool modal=false, bool use_header_bar=false)
void | add_action_widget (Widget& child, int response_id)
| Adds an activatable widget to the action area of a Gtk::Dialog, connecting a signal handler that will emit the Gtk::Dialog::signal_response() signal on the dialog when the widget is activated. More...
Button* | add_button (const Glib::ustring& button_text, int response_id)
| Adds a button with the given text and sets things up so that clicking the button will emit the Gtk::Dialog::signal_response() signal with the given response_id. More...
void | set_response_sensitive (int response_id, bool setting=true)
| Calls `gtk_widget_set_sensitive (widget, @a setting)` for each widget in the dialog’s action area with the given response_id. More...
void | set_default_response (int response_id)
| Sets the last widget in the dialog’s action area with the given response_id as the default widget for the dialog. More...
Widget* | get_widget_for_response (int response_id)
| Gets the widget button that uses the given response ID in the action area of a dialog. More...
const Widget* | get_widget_for_response (int response_id) const
| Gets the widget button that uses the given response ID in the action area of a dialog. More...
int | get_response_for_widget (const Gtk::Widget& widget) const
| Gets the response id of a widget in the action area of a dialog. More...
void | response (int response_id)
| Emits the Gtk::Dialog::signal_response() signal with the given response ID. More...
int | run ()
| Blocks in a recursive main loop until the dialog either emits the Gtk::Dialog::signal_response() signal, or is destroyed. More...
Box* | get_content_area ()
| Returns the content area of dialog. More...
const Box* | get_content_area () const
| Returns the content area of dialog. More...
HeaderBar* | get_header_bar ()
| Returns the header bar of dialog. More...
const HeaderBar* | get_header_bar () const
| Returns the header bar of dialog. More...
Glib::SignalProxy< void(int)> | signal_response ()
Glib::PropertyProxy_ReadOnly< bool > | property_use_header_bar () const
| `true` if the dialog uses a Gtk::HeaderBar for action buttons instead of the action-area. More...
Public Member Functions inherited from Gtk::Window
| Window (Window&& src) noexcept
Window& | operator= (Window&& src) noexcept
| Window (const Window&)=delete
Window& | operator= (const Window&)=delete
| ~Window () noexceptoverride
GtkWindow* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkWindow* | gobj () const
| Provides access to the underlying C GtkObject. More...
| Window (WindowType type=WindowType::TOPLEVEL)
Glib::PropertyProxy_ReadOnly< WindowType > | property_type () const
| The type of the window. More...
Glib::PropertyProxy< Glib::ustring > | property_title ()
| The title of the window. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_title () const
| The title of the window. More...
Glib::PropertyProxy_WriteOnly< Glib::ustring > | property_startup_id ()
| The :startup-id is a write-only property for setting window's startup notification identifier. More...
Glib::PropertyProxy< bool > | property_resizable ()
| If TRUE, users can resize the window. More...
Glib::PropertyProxy_ReadOnly< bool > | property_resizable () const
| If TRUE, users can resize the window. More...
Glib::PropertyProxy< bool > | property_modal ()
| If TRUE, the window is modal (other windows are not usable while this one is up). More...
Glib::PropertyProxy_ReadOnly< bool > | property_modal () const
| If TRUE, the window is modal (other windows are not usable while this one is up). More...
Glib::PropertyProxy< WindowPosition > | property_window_position ()
| The initial position of the window. More...
Glib::PropertyProxy_ReadOnly< WindowPosition > | property_window_position () const
| The initial position of the window. More...
Glib::PropertyProxy< int > | property_default_width ()
| The default width of the window, used when initially showing the window. More...
Glib::PropertyProxy_ReadOnly< int > | property_default_width () const
| The default width of the window, used when initially showing the window. More...
Glib::PropertyProxy< int > | property_default_height ()
| The default height of the window, used when initially showing the window. More...
Glib::PropertyProxy_ReadOnly< int > | property_default_height () const
| The default height of the window, used when initially showing the window. More...
Glib::PropertyProxy< bool > | property_destroy_with_parent ()
| If this window should be destroyed when the parent is destroyed. More...
Glib::PropertyProxy_ReadOnly< bool > | property_destroy_with_parent () const
| If this window should be destroyed when the parent is destroyed. More...
Glib::PropertyProxy< Glib::RefPtr< Gdk::Pixbuf > > | property_icon ()
| Icon for this window. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Pixbuf > > | property_icon () const
| Icon for this window. More...
Glib::PropertyProxy< bool > | property_mnemonics_visible ()
| Whether mnemonics are currently visible in this window. More...
Glib::PropertyProxy_ReadOnly< bool > | property_mnemonics_visible () const
| Whether mnemonics are currently visible in this window. More...
Glib::PropertyProxy< Glib::ustring > | property_icon_name ()
| The :icon-name property specifies the name of the themed icon to use as the window icon. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_icon_name () const
| The :icon-name property specifies the name of the themed icon to use as the window icon. More...
Glib::PropertyProxy< Glib::RefPtr< Gdk::Screen > > | property_screen ()
| The screen where this window will be displayed. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Screen > > | property_screen () const
| The screen where this window will be displayed. More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_active () const
| Whether the toplevel is the current active window. More...
Glib::PropertyProxy< Gdk::Window::TypeHint > | property_type_hint ()
| Hint to help the desktop environment understand what kind of window this is and how to treat it. More...
Glib::PropertyProxy_ReadOnly< Gdk::Window::TypeHint > | property_type_hint () const
| Hint to help the desktop environment understand what kind of window this is and how to treat it. More...
Glib::PropertyProxy< bool > | property_skip_taskbar_hint ()
| TRUE if the window should not be in the task bar. More...
Glib::PropertyProxy_ReadOnly< bool > | property_skip_taskbar_hint () const
| TRUE if the window should not be in the task bar. More...
Glib::PropertyProxy< bool > | property_skip_pager_hint ()
| TRUE if the window should not be in the pager. More...
Glib::PropertyProxy_ReadOnly< bool > | property_skip_pager_hint () const
| TRUE if the window should not be in the pager. More...
Glib::PropertyProxy< Glib::ustring > | property_role ()
| Unique identifier for the window to be used when restoring a session. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_role () const
| Unique identifier for the window to be used when restoring a session. More...
Glib::PropertyProxy< bool > | property_decorated ()
| Whether the window should be decorated by the window manager. More...
Glib::PropertyProxy_ReadOnly< bool > | property_decorated () const
| Whether the window should be decorated by the window manager. More...
Glib::PropertyProxy< Gdk::Gravity > | property_gravity ()
| The window gravity of the window. More...
Glib::PropertyProxy_ReadOnly< Gdk::Gravity > | property_gravity () const
| The window gravity of the window. More...
Glib::PropertyProxy< Window* > | property_transient_for ()
| The transient parent of the window. More...
Glib::PropertyProxy_ReadOnly< Window* > | property_transient_for () const
| The transient parent of the window. More...
Glib::PropertyProxy< bool > | property_urgency_hint ()
| TRUE if the window should be brought to the user’s attention. More...
Glib::PropertyProxy_ReadOnly< bool > | property_urgency_hint () const
| TRUE if the window should be brought to the user’s attention. More...
Glib::PropertyProxy< bool > | property_accept_focus ()
| Whether the window should receive the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_accept_focus () const
| Whether the window should receive the input focus. More...
Glib::PropertyProxy< bool > | property_focus_on_map ()
| Whether the window should receive the input focus when mapped. More...
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_map () const
| Whether the window should receive the input focus when mapped. More...
Glib::PropertyProxy< bool > | property_deletable ()
| Whether the window frame should have a close button. More...
Glib::PropertyProxy_ReadOnly< bool > | property_deletable () const
| Whether the window frame should have a close button. More...
Glib::PropertyProxy< Glib::RefPtr< Application > > | property_application ()
| The Gtk::Application associated with the window. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Application > > | property_application () const
| The Gtk::Application associated with the window. More...
Glib::PropertyProxy< bool > | property_focus_visible ()
| Whether 'focus rectangles' are currently visible in this window. More...
Glib::PropertyProxy_ReadOnly< bool > | property_focus_visible () const
| Whether 'focus rectangles' are currently visible in this window. More...
Glib::PropertyProxy< Widget* > | property_attached_to ()
| The widget to which this window is attached. More...
Glib::PropertyProxy_ReadOnly< Widget* > | property_attached_to () const
| The widget to which this window is attached. More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_maximized () const
| Whether the window is maximized. More...
Glib::SignalProxy< void(Widget*)> | signal_set_focus ()
Glib::SignalProxy< void()> | signal_keys_changed ()
void | set_title (const Glib::ustring& title)
| Sets the title of the Gtk::Window. More...
Glib::ustring | get_title () const
| Retrieves the title of the window. More...
void | set_role (const Glib::ustring& role)
| This function is only useful on X11, not with other GTK+ targets. More...
void | set_startup_id (const Glib::ustring& startup_id)
| Startup notification identifiers are used by desktop environment to track application startup, to provide user feedback and other features. More...
Glib::ustring | get_role () const
| Returns the role of the window. More...
void | add_accel_group (const Glib::RefPtr< AccelGroup >& accel_group)
| Associate accel_group with window, such that calling gtk_accel_groups_activate() on window will activate accelerators in accel_group. More...
void | remove_accel_group (const Glib::RefPtr< AccelGroup >& accel_group)
| Reverses the effects of add_accel_group(). More...
void | set_position (WindowPosition position)
| Sets a position constraint for this window. More...
bool | activate_focus ()
| Activates the current focused widget within the window. More...
void | set_focus (Gtk::Widget& focus)
| If focus is not the current focus widget, and is focusable, sets it as the focus widget for the window. More...
void | unset_focus ()
Widget* | get_focus ()
| Retrieves the current focused widget within the window. More...
const Widget* | get_focus () const
| Retrieves the current focused widget within the window. More...
void | set_default (Gtk::Widget& default_widget)
| The default widget is the widget that’s activated when the user presses Enter in a dialog (for example). More...
void | unset_default ()
Widget* | get_default_widget ()
| Returns the default widget for window. More...
const Widget* | get_default_widget () const
| Returns the default widget for window. More...
bool | activate_default ()
| Activates the default widget for the window, unless the current focused widget has been configured to receive the default action (see Gtk::Widget::set_receives_default()), in which case the focused widget is activated. More...
void | set_transient_for (Window& parent)
| Dialog windows should be set transient for the main application window they were spawned from. More...
void | unset_transient_for ()
| Unsets the current transient window. More...
Window* | get_transient_for ()
| Fetches the transient parent for this window. More...
const Window* | get_transient_for () const
| Fetches the transient parent for this window. More...
void | unset_attached_to ()
| Unsets the attached-to widget. More...
void | set_attached_to (Widget& attach_widget)
| Marks window as attached to attach_widget. More...
Widget* | get_attached_to ()
| Fetches the attach widget for this window. More...
const Widget* | get_attached_to () const
| Fetches the attach widget for this window. More...
void | set_type_hint (Gdk::Window::TypeHint hint)
| By setting the type hint for the window, you allow the window manager to decorate and handle the window in a way which is suitable to the function of the window in your application. More...
Gdk::Window::TypeHint | get_type_hint () const
| Gets the type hint for this window. More...
void | set_skip_taskbar_hint (bool setting=true)
| Windows may set a hint asking the desktop environment not to display the window in the task bar. More...
bool | get_skip_taskbar_hint () const
| Gets the value set by set_skip_taskbar_hint() More...
void | set_skip_pager_hint (bool setting=true)
| Windows may set a hint asking the desktop environment not to display the window in the pager. More...
bool | get_skip_pager_hint () const
| Gets the value set by set_skip_pager_hint(). More...
void | set_urgency_hint (bool setting=true)
| Windows may set a hint asking the desktop environment to draw the users attention to the window. More...
bool | get_urgency_hint () const
| Gets the value set by set_urgency_hint() More...
void | set_accept_focus (bool setting=true)
| Windows may set a hint asking the desktop environment not to receive the input focus. More...
bool | get_accept_focus () const
| Gets the value set by set_accept_focus(). More...
void | set_focus_on_map (bool setting=true)
| Windows may set a hint asking the desktop environment not to receive the input focus when the window is mapped. More...
bool | get_focus_on_map () const
| Gets the value set by set_focus_on_map(). More...
bool | get_destroy_with_parent () const
| Returns whether the window will be destroyed with its transient parent. More...
void | set_mnemonics_visible (bool setting=true)
| Sets the Gtk::Window::property_mnemonics_visible() property. More...
bool | get_mnemonics_visible () const
| Gets the value of the Gtk::Window::property_mnemonics_visible() property. More...
void | set_focus_visible (bool setting=true)
| Sets the Gtk::Window::property_focus_visible() property. More...
bool | get_focus_visible () const
| Gets the value of the Gtk::Window::property_focus_visible() property. More...
void | set_resizable (bool resizable=true)
| Sets whether the user can resize a window. More...
bool | get_resizable () const
| Gets the value set by set_resizable(). More...
void | set_gravity (Gdk::Gravity gravity)
| Window gravity defines the meaning of coordinates passed to move(). More...
Gdk::Gravity | get_gravity () const
| Gets the value set by set_gravity(). More...
void | set_screen (const Glib::RefPtr< Gdk::Screen >& screen)
| Sets the Gdk::Screen where the window is displayed; if the window is already mapped, it will be unmapped, and then remapped on the new screen. More...
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Returns the Gdk::Screen associated with window. More...
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Returns the Gdk::Screen associated with window. More...
bool | is_active () const
| Returns whether the window is part of the current active toplevel. More...
void | set_decorated (bool setting=true)
| By default, windows are decorated with a title bar, resize controls, etc. More...
bool | get_decorated () const
| Returns whether the window has been set to have decorations such as a title bar via set_decorated(). More...
void | set_deletable (bool setting=true)
| By default, windows have a close button in the window frame. More...
bool | get_deletable () const
| Returns whether the window has been set to have a close button via set_deletable(). More...
std::vector< Glib::RefPtr< Gdk::Pixbuf > > | get_icon_list ()
| Retrieves the list of icons set by set_icon_list(). More...
std::vector< Glib::RefPtr< const Gdk::Pixbuf > > | get_icon_list () const
| Retrieves the list of icons set by set_icon_list(). More...
void | set_icon_list (const std::vector< Glib::RefPtr< Gdk::Pixbuf > >& list)
| Sets up the icon representing a Gtk::Window. More...
void | set_icon (const Glib::RefPtr< Gdk::Pixbuf >& icon)
| Sets up the icon representing a Gtk::Window. More...
void | set_icon_name (const Glib::ustring& name)
| Sets the icon for the window from a named themed icon. More...
bool | set_icon_from_file (const std::string& filename)
| Sets the icon for the window. More...
Glib::RefPtr< Gdk::Pixbuf > | get_icon ()
| Gets the value set by set_icon() (or if you've called set_icon_list(), gets the first icon in the icon list). More...
Glib::RefPtr< const Gdk::Pixbuf > | get_icon () const
| Gets the value set by set_icon() (or if you've called set_icon_list(), gets the first icon in the icon list). More...
Glib::ustring | get_icon_name () const
| Returns the name of the themed icon for the window, see set_icon_name(). More...
void | set_modal (bool modal=true)
| Sets a window modal or non-modal. More...
bool | get_modal () const
| Returns whether the window is modal. More...
void | add_mnemonic (guint keyval, Widget& target)
| Adds a mnemonic to this window. More...
void | remove_mnemonic (guint keyval, Widget& target)
| Removes a mnemonic from this window. More...
bool | mnemonic_activate (guint keyval, Gdk::ModifierType modifier)
| Activates the targets associated with the mnemonic. More...
void | set_mnemonic_modifier (Gdk::ModifierType modifier)
| Sets the mnemonic modifier for this window. More...
Gdk::ModifierType | get_mnemonic_modifier ()
| Returns the mnemonic modifier for this window. More...
void | present ()
| Presents a window to the user. More...
void | present (guint32 timestamp)
| Presents a window to the user in response to a user interaction. More...
void | iconify ()
| Asks to iconify (i.e. minimize) the specified window. More...
void | deiconify ()
| Asks to deiconify (i.e. unminimize) the specified window. More...
void | stick ()
| Asks to stick window, which means that it will appear on all user desktops. More...
void | unstick ()
| Asks to unstick window, which means that it will appear on only one of the user’s desktops. More...
void | maximize ()
| Asks to maximize window, so that it becomes full-screen. More...
void | unmaximize ()
| Asks to unmaximize window. More...
void | fullscreen ()
| Asks to place window in the fullscreen state. More...
void | unfullscreen ()
| Asks to toggle off the fullscreen state for window. More...
void | fullscreen_on_monitor (const Glib::RefPtr< Gdk::Screen >& screen, int monitor)
| Asks to place window in the fullscreen state. More...
void | close ()
| Requests that the window is closed, similar to what happens when a window manager close button is clicked. More...
void | begin_resize_drag (Gdk::WindowEdge edge, int button, int root_x, int root_y, guint32 timestamp)
| Starts resizing a window. More...
void | begin_move_drag (int button, int root_x, int root_y, guint32 timestamp)
| Starts moving a window. More...
void | set_default_size (int width, int height)
| Sets the default size of a window. More...
void | get_default_size (int& width, int& height) const
| Gets the default size of the window. More...
void | resize (int width, int height)
| Resizes the window as if the user had done so, obeying geometry constraints. More...
void | get_size (int& width, int& height) const
| Obtains the current size of window. More...
void | move (int x, int y)
| Asks the [window manager][gtk-X11-arch] to move window to the given position. More...
void | get_position (int& root_x, int& root_y) const
| This function returns the position you need to pass to move() to keep window in its current position. More...
Glib::RefPtr< WindowGroup > | get_group ()
| Returns the group for window or the default group, if window is `nullptr` or if window does not have an explicit window group. More...
Glib::RefPtr< const WindowGroup > | get_group () const
| Returns the group for window or the default group, if window is `nullptr` or if window does not have an explicit window group. More...
bool | has_group () const
| Returns whether window has an explicit window group. More...
WindowType | get_window_type () const
| Gets the type of the window. More...
Glib::RefPtr< Application > | get_application ()
| Gets the Gtk::Application associated with the window (if any). More...
Glib::RefPtr< const Application > | get_application () const
| Gets the Gtk::Application associated with the window (if any). More...
void | set_application (const Glib::RefPtr< Application >& application)
| Sets or unsets the Gtk::Application associated with the window. More...
void | unset_application ()
| Unsets the Application associated with the window. More...
void | set_keep_above (bool setting=true)
| Asks to keep window above, so that it stays on top. More...
void | set_keep_below (bool setting=true)
| Asks to keep window below, so that it stays in bottom. More...
void | set_titlebar (Widget& titlebar)
| Sets a custom titlebar for window. More...
Widget* | get_titlebar ()
| Returns the custom titlebar that has been set with set_titlebar(). More...
const Widget* | get_titlebar () const
| Returns the custom titlebar that has been set with set_titlebar(). More...
bool | is_maximized () const
| Retrieves the current maximized state of window. More...
Glib::RefPtr< AccelGroup > | get_accel_group ()
| Returns a default accel group for this window This is a gtkmm-specific function. More...
void | raise ()
| Brings the window to the front. More...
void | set_manage () override
| Overriden to warn that it doesn't make sense to use Gtk::manage() on this class because it has no parent container. More...
Public Member Functions inherited from Gtk::Bin
| Bin (Bin&& src) noexcept
Bin& | operator= (Bin&& src) noexcept
| Bin (const Bin&)=delete
Bin& | operator= (const Bin&)=delete
| ~Bin () noexceptoverride
GtkBin* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkBin* | gobj () const
| Provides access to the underlying C GtkObject. More...
Gtk::Widget* | get_child ()
| Gets the child of the Gtk::Bin, or `nullptr` if the bin contains no child widget. More...
const Gtk::Widget* | get_child () const
| Gets the child of the Gtk::Bin, or `nullptr` if the bin contains no child widget. More...
void | remove ()
| Remove the contained widget. More...
void | add_label (const Glib::ustring& label, bool mnemonic=false, Align x_align=Align::CENTER, Align y_align=Align::CENTER)
| Add a Label object. More...
void | add_pixlabel (const std::string& pixfile, const Glib::ustring& label, Align x_align=Align::CENTER, Align y_align=Align::CENTER)
| Add Image and Label objects. More...
Public Member Functions inherited from Gtk::Container
| Container (Container&& src) noexcept
Container& | operator= (Container&& src) noexcept
| Container (const Container&)=delete
Container& | operator= (const Container&)=delete
| ~Container () noexceptoverride
GtkContainer* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkContainer* | gobj () const
| Provides access to the underlying C GtkObject. More...
void | add (Widget& widget)
| Adds widget to container. More...
void | remove (Widget& widget)
| Removes widget from the container. More...
void | check_resize ()
| Request that contained widgets check their size. More...
void | foreach (const ForeachSlot& slot)
| Operate on contained items. More...
void | forall (const ForeachSlot& slot)
| Operate on contained items, including internal children. More...
std::vector< Widget* > | get_children ()
| Returns the container’s non-internal children. More...
std::vector< const Widget* > | get_children () const
| Returns the container’s non-internal children. More...
void | set_focus_chain (const std::vector< Widget* >& focusable_widgets)
| Sets a focus chain, overriding the one computed automatically by GTK+. More...
bool | has_focus_chain () const
std::vector< Widget* > | get_focus_chain ()
std::vector< const Widget* > | get_focus_chain () const
void | unset_focus_chain ()
| Removes a focus chain explicitly set with set_focus_chain(). More...
void | set_focus_vadjustment (const Glib::RefPtr< Adjustment >& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Glib::RefPtr< Adjustment > | get_focus_vadjustment ()
| Retrieves the vertical focus adjustment for the container. More...
Glib::RefPtr< const Adjustment > | get_focus_vadjustment () const
| Retrieves the vertical focus adjustment for the container. More...
void | set_focus_hadjustment (const Glib::RefPtr< Adjustment >& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Glib::RefPtr< Adjustment > | get_focus_hadjustment ()
| Retrieves the horizontal focus adjustment for the container. More...
Glib::RefPtr< const Adjustment > | get_focus_hadjustment () const
| Retrieves the horizontal focus adjustment for the container. More...
GType | child_type () const
| Returns the type of the children supported by the container. More...
WidgetPath | get_path_for_child (const Widget& child) const
| Returns a newly created widget path representing all the widget hierarchy from the toplevel down to and including child. More...
Glib::SignalProxy< void(Widget*)> | signal_add ()
Glib::SignalProxy< void(Widget*)> | signal_remove ()
Glib::SignalProxy< void()> | signal_check_resize ()
Public Member Functions inherited from Gtk::Widget
| Widget (Widget&& src) noexcept
Widget& | operator= (Widget&& src) noexcept
| Widget (const Widget&)=delete
Widget& | operator= (const Widget&)=delete
| ~Widget () noexceptoverride
| Destroys the widget. More...
GtkWidget* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkWidget* | gobj () const
| Provides access to the underlying C GtkObject. More...
void | show ()
| Flags a widget to be displayed. More...
void | show_now ()
| Shows a widget. More...
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user). More...
void | queue_draw ()
| Equivalent to calling queue_draw_area() for the entire area of a widget. More...
void | queue_draw_area (int x, int y, int width, int height)
| Convenience function that calls queue_draw_region() on the region created from the given coordinates. More...
void | queue_draw_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Invalidates the area of widget defined by region by notifying the parent via its GtkWidgetClass::queue_draw_child() function. More...
void | queue_resize ()
| This function is only for use in widget implementations. More...
void | queue_allocate ()
| This function is only for use in widget implementations. More...
void | size_allocate (const Allocation& allocation, int baseline, Allocation& out_clip)
| This function is only used by Gtk::Widget subclasses, to assign a size, position and (optionally) baseline to their child widgets. More...
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout. More...
void | measure (Orientation orientation, int for_size, int& minimum, int& natural, int& minimum_baseline, int& natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size. More...
void | get_preferred_size (Requisition& minimum_size, Requisition& natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management. More...
void | add_accelerator (const Glib::ustring& accel_signal, const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods, AccelFlags accel_flags)
| Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated. More...
bool | remove_accelerator (const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator from widget, previously installed with add_accelerator(). More...
void | set_accel_path (const Glib::ustring& accel_path, const Glib::RefPtr< AccelGroup >& accel_group)
| Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated. More...
bool | mnemonic_activate (bool group_cycling)
| Emits the Gtk::Widget::signal_mnemonic_activate() signal. More...
bool | event (const Gdk::Event& gdk_event)
| Rarely-used function. More...
bool | send_focus_change (Gdk::EventFocus& gdk_event)
| Sends the focus change gdk_event to widget. More...
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them. More...
void | reparent (Container& new_parent)
| Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget. More...
bool | intersect (const Gdk::Rectangle& area) const
bool | intersect (const Gdk::Rectangle& area, Gdk::Rectangle& intersection) const
| Computes the intersection of a widget’s area and area, storing the intersection in intersection, and returns `true` if there was an intersection. More...
void | freeze_child_notify ()
| Stops emission of Gtk::Widget::signal_child_notify() signals on widget. More...
void | child_notify (const Glib::ustring& child_property)
| Emits a Gtk::Widget::signal_child_notify() signal for the [child property][child-properties] child_property on widget. More...
void | thaw_child_notify ()
| Reverts the effect of a previous call to freeze_child_notify(). More...
void | set_can_focus (bool can_focus=true)
| Specifies whether widget can own the input focus. More...
bool | get_can_focus () const
| Determines whether widget can own the input focus. More...
bool | has_focus () const
| Determines if the widget has the global input focus. More...
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel. More...
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus. More...
void | grab_focus ()
| Causes widget to have the keyboard focus for the Gtk::Window it's inside. More...
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse. More...
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse. More...
void | set_can_default (bool can_default=true)
| Specifies whether widget can be a default widget. More...
bool | get_can_default () const
| Determines whether widget can be a default widget. More...
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel. More...
void | grab_default ()
| Causes widget to become the default widget. More...
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | get_receives_default () const
| Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | has_grab () const
| Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse). More...
bool | device_is_shadowed (const Glib::RefPtr< const Gdk::Device >& device)
| Returns `true` if device has been shadowed by a GTK+ device grab on another widget, so it would stop sending events to widget. More...
void | add_modal_grab ()
| Block events to everything else than this widget and its children. More...
void | remove_modal_grab ()
| Remove the modal grab of the widget in case it was previously grabbed. More...
void | set_name (const Glib::ustring& name)
| Widgets can be named, which allows you to refer to them from a CSS file. More...
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget. More...
void | set_state_flags (StateFlags flags, bool clear=true)
| This function is for use in widget implementations. More...
void | unset_state_flags (StateFlags flags)
| This function is for use in widget implementations. More...
StateFlags | get_state_flags () const
| Returns the widget state as a flag set. More...
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget. More...
bool | get_sensitive () const
| Returns the widget’s sensitivity (in the sense of returning the value that has been set using set_sensitive()). More...
bool | is_sensitive () const
| Returns the widget’s effective sensitivity, which means it is sensitive itself and also its parent widget is sensitive. More...
void | set_visible (bool visible=true)
| Sets the visibility state of widget. More...
bool | get_visible () const
| Determines whether the widget is visible. More...
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible. More...
bool | get_has_window () const
| Determines whether widget has a Gdk::Window of its own. More...
bool | get_is_toplevel () const
| Determines whether widget is a toplevel widget. More...
bool | get_is_drawable () const
| Determines whether widget can be drawn to. More...
bool | get_realized () const
| Determines whether widget is realized. More...
bool | get_mapped () const
| Whether the widget is mapped. More...
void | set_child_visible (bool visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show(). More...
bool | get_child_visible () const
| Gets the value set with set_child_visible(). More...
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the widget’s window if it is realized, `nullptr` otherwise. More...
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the widget’s window if it is realized, `nullptr` otherwise. More...
void | register_window (const Glib::RefPtr< Gdk::Window >& window)
| Registers a Gdk::Window with the widget and sets it up so that the widget receives events for it. More...
void | unregister_window (const Glib::RefPtr< Gdk::Window >& window)
| Unregisters a Gdk::Window from the widget that was previously set up with register_window(). More...
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget. More...
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget. More...
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to widget. More...
void | get_allocated_size (Allocation& allocation, int& baseline) const
| Retrieves the widget’s allocated size. More...
Allocation | get_allocation () const
| Retrieves the widget's location. More...
Allocation | get_clip () const
| Retrieves the widget’s clip area. More...
Container* | get_parent ()
| Returns the parent widget of widget. More...
const Container* | get_parent () const
| Returns the parent widget of widget. More...
Glib::RefPtr< Gdk::Window > | get_parent_window ()
| Gets widget’s parent window. More...
Glib::RefPtr< const Gdk::Window > | get_parent_window () const
| Gets widget’s parent window. More...
void | set_parent_window (const Glib::RefPtr< const Gdk::Window >& parent_window)
| Sets a non default parent window for widget. More...
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you’d use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order. More...
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary. More...
void | error_bell ()
| Notifies the user about an input-related error on this widget. More...
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget’s size request will be at least width by height. More...
void | get_size_request (int& width, int& height) const
| Gets the size request that was explicitly set for the widget using set_size_request(). More...
void | set_opacity (double opacity)
| Request the widget to be rendered partially transparent, with opacity 0 being fully transparent and 1 fully opaque. More...
double | get_opacity () const
| Fetches the requested opacity for this widget. More...
void | set_device_enabled (const Glib::RefPtr< Gdk::Device >& device, bool enabled=true)
| Enables or disables a Gdk::Device to interact with widget and all its children. More...
bool | get_device_enabled (const Glib::RefPtr< const Gdk::Device >& device) const
| Returns whether device can interact with widget and its children. More...
Container* | get_toplevel ()
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
const Container* | get_toplevel () const
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
Widget* | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type. More...
const Widget* | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type. More...
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
bool | has_screen () const
| Checks whether there is a Gdk::Screen is associated with this widget. More...
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels. More...
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget. More...
Glib::RefPtr< Clipboard > | get_clipboard (const Glib::ustring& selection)
| Returns the clipboard object for the given selection to be used with widget. More...
Glib::RefPtr< const Clipboard > | get_clipboard (const Glib::ustring& selection) const
| Returns the clipboard object for the given selection to be used with widget. More...
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space. More...
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space. More...
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag (see get_hexpand()) will be used. More...
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space. More...
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space. More...
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag (see get_vexpand()) will be used. More...
void | queue_compute_expand ()
| Mark widget as needing to recompute its expand flags. More...
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible. More...
bool | get_support_multidevice () const
| Returns `true` if widget is multiple pointer aware. More...
void | set_support_multidevice (bool support_multidevice=true)
| Enables or disables multiple pointer awareness. More...
Glib::RefPtr< Atk::Object > | get_accessible ()
| Returns the accessible object that describes the widget to an assistive technology. More...
Glib::RefPtr< const Atk::Object > | get_accessible () const
| Returns the accessible object that describes the widget to an assistive technology. More...
Align | get_halign () const
| Gets the value of the Gtk::Widget::property_halign() property. More...
void | set_halign (Align align)
| Sets the horizontal alignment of widget. More...
Align | get_valign () const
| Gets the value of the Gtk::Widget::property_valign() property. More...
void | set_valign (Align align)
| Sets the vertical alignment of widget. More...
int | get_margin_start () const
| Gets the value of the Gtk::Widget::property_margin_start() property. More...
void | set_margin_start (int margin)
| Sets the start margin of widget. More...
int | get_margin_end () const
| Gets the value of the Gtk::Widget::property_margin_end() property. More...
void | set_margin_end (int margin)
| Sets the end margin of widget. More...
int | get_margin_top () const
| Gets the value of the Gtk::Widget::property_margin_top() property. More...
void | set_margin_top (int margin)
| Sets the top margin of widget. More...
int | get_margin_bottom () const
| Gets the value of the Gtk::Widget::property_margin_bottom() property. More...
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget. More...
void | set_margin (int margin)
| Set all 4 margins to the same value. More...
bool | is_ancestor (Widget& ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers. More...
bool | translate_coordinates (Widget& dest_widget, int src_x, int src_y, int& dest_x, int& dest_y)
| Translate coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations. More...
void | reset_style ()
| Updates the style context of widget and all descendants by updating its widget path. More...
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font options, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget. More...
void | set_font_options (const ::Cairo::FontOptions& options)
| Sets the #cairo_font_options_t used for Pango rendering in this widget. More...
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options(). More...
::Cairo::FontOptions | get_font_options () const
| Returns the #cairo_font_options_t used for Pango rendering. More...
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring& text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget. More...
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget. More...
TextDirection | get_direction () const
| Gets the reading direction for a particular widget. More...
void | shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets a shape for this widget’s GDK window. More...
void | input_shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets an input shape for this widget’s GDK window. More...
WidgetPath | get_path () const
| Returns the Gtk::WidgetPath representing widget, if the widget is not connected to a toplevel widget, a partial path will be created. More...
std::vector< Widget* > | list_mnemonic_labels ()
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
std::vector< const Widget* > | list_mnemonic_labels () const
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
void | add_mnemonic_label (Widget& label)
| Adds a widget to the list of mnemonic labels for this widget. More...
void | remove_mnemonic_label (Widget& label)
| Removes a widget from the list of mnemonic labels for this widget. More...
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::ustring& target, guint32 time)
void | drag_highlight ()
void | drag_unhighlight ()
void | drag_dest_set (DestDefaults flags=DestDefaults(0), Gdk::DragAction actions=Gdk::DragAction(0))
void | drag_dest_set (const std::vector< TargetEntry >& targets, DestDefaults flags=DestDefaults::ALL, Gdk::DragAction actions=Gdk::DragAction::COPY)
void | drag_dest_unset ()
| Clears information about a drop destination set with gtk_drag_dest_set(). More...
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::RefPtr< TargetList >& target_list) const
| Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning GDK_NONE. More...
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context) const
Glib::RefPtr< TargetList > | drag_dest_get_target_list ()
| Returns the list of targets this widget can accept from drag-and-drop. More...
Glib::RefPtr< const TargetList > | drag_dest_get_target_list () const
| Returns the list of targets this widget can accept from drag-and-drop. More...
void | drag_dest_set_target_list (const Glib::RefPtr< TargetList >& target_list)
| Sets the target types that this widget can accept from drag-and-drop. More...
void | drag_dest_add_text_targets ()
| Add the text targets supported by Gtk::SelectionData to the target list of the drag destination. More...
void | drag_dest_add_image_targets ()
| Add the image targets supported by Gtk::SelectionData to the target list of the drag destination. More...
void | drag_dest_add_uri_targets ()
| Add the URI targets supported by Gtk::SelectionData to the target list of the drag destination. More...
void | drag_source_set (const std::vector< TargetEntry >& targets, Gdk::ModifierType start_button_mask=Gdk::ModifierType::MODIFIER_MASK, Gdk::DragAction actions=Gdk::DragAction::COPY)
void | drag_source_unset ()
| Undoes the effects of gtk_drag_source_set(). More...
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Pixbuf >& pixbuf)
| Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf. More...
void | drag_source_set_icon (const Glib::ustring& icon_name)
| Sets the icon that will be used for drags from a particular source to a themed icon. More...
void | drag_source_add_text_targets ()
| Add the text targets supported by Gtk::SelectionData to the target list of the drag source. More...
void | drag_source_add_uri_targets ()
| Add the URI targets supported by Gtk::SelectionData to the target list of the drag source. More...
void | drag_source_add_image_targets ()
| Add the writable image targets supported by Gtk::SelectionData to the target list of the drag source. More...
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList >& targets, Gdk::DragAction actions, int button, Gdk::Event& gdk_event, int x, int y)
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
void | drag_set_as_icon (const Glib::RefPtr< Gdk::DragContext >& context, int hot_x, int hot_y)
void | queue_resize_no_redraw ()
| This function works like queue_resize(), except that the widget is not invalidated. More...
void | set_parent (Widget& parent)
| This function is useful only when implementing subclasses of Gtk::Widget. More...
void | unparent ()
| This function is only for use in widget implementations. More...
void | map ()
| This function is only for use in widget implementations. More...
void | unmap ()
| This function is only for use in widget implementations. More...
void | set_tooltip_window (Window& custom_window)
| Replaces the default, usually yellow, window used for displaying tooltips with custom_window. More...
Window* | get_tooltip_window ()
| Returns the Gtk::Window of the current tooltip. More...
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located. More...
void | set_tooltip_text (const Glib::ustring& text)
| Sets text as the contents of the tooltip. More...
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget. More...
void | set_tooltip_markup (const Glib::ustring& markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language. More...
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget. More...
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip. More...
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property. More...
int | get_width () const
int | get_height () const
bool | in_destruction () const
| Returns whether the widget is currently being destroyed. More...
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget. More...
Glib::RefPtr< Gtk::StyleContext > | get_style_context () const
| Returns the style context associated to widget. More...
Gdk::ModifierType | get_modifier_mask (Gdk::ModifierIntent intent)
| Returns the modifier mask the widget’s windowing system backend uses for a particular purpose. More...
void | insert_action_group (const Glib::ustring& name, const Glib::RefPtr< Gio::ActionGroup >& group)
| Inserts group into widget. More...
void | remove_action_group (const Glib::ustring& name)
| Removes a group from the widget. More...
Glib::RefPtr< Gio::ActionGroup > | get_action_group (const Glib::ustring& prefix)
| Retrieves the Gio::ActionGroup that was registered using prefix. More...
Glib::RefPtr< const Gio::ActionGroup > | get_action_group (const Glib::ustring& prefix) const
| Retrieves the Gio::ActionGroup that was registered using prefix. More...
std::vector< Glib::ustring > | list_action_prefixes () const
| Retrieves a `nullptr`-terminated array of strings containing the prefixes of Gio::ActionGroup's available to widget. More...
void | set_font_map (const Glib::RefPtr< Pango::FontMap >& font_map)
| Sets the font map to use for Pango rendering. More...
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map that has been set with set_font_map(). More...
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map that has been set with set_font_map(). More...
Widget* | get_first_child ()
const Widget* | get_first_child () const
Widget* | get_last_child ()
const Widget* | get_last_child () const
Widget* | get_next_sibling ()
const Widget* | get_next_sibling () const
Widget* | get_prev_sibling ()
const Widget* | get_prev_sibling () const
void | insert_after (Widget& parent, Widget& previous_sibling)
| Inserts widget into the child widget list of parent. More...
void | insert_after (Widget& parent)
| A insert_after() convenience overload. More...
void | insert_before (Widget& parent, Widget& next_sibling)
| Inserts widget into the child widget list of parent. More...
void | insert_before (Widget& parent)
| A insert_before() convenience overload. More...
void | snapshot_child (Widget& child, Snapshot& snapshot)
| When a widget receives a call to the snapshot function, it must send synthetic Gtk::Widget::signal_snapshot() calls to all children. More...
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen. More...
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget. More...
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(const Allocation&, int, Allocation&)> | signal_size_allocate ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(Widget*)> | signal_parent_changed ()
| Informs objects that their parent changed. More...
Glib::SignalProxy< void(Widget*)> | signal_hierarchy_changed ()
Glib::SignalProxy< void()> | signal_style_updated ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< void(bool)> | signal_grab_notify ()
Glib::SignalProxy< void(GParamSpec*)> | signal_child_notify ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_grab_focus ()
Glib::SignalProxy< bool(DirectionType)> | signal_focus ()
Glib::SignalProxy< bool(Gdk::Event&)> | signal_event ()
Glib::SignalProxy< void(Gdk::Event&)> | signal_event_after ()
Glib::SignalProxy< bool(Gdk::EventButton&)> | signal_button_press_event ()
| Event triggered by user pressing button. More...
Glib::SignalProxy< bool(Gdk::EventButton&)> | signal_button_release_event ()
| Event triggered by user releasing button. More...
Glib::SignalProxy< bool(Gdk::EventScroll&)> | signal_scroll_event ()
Glib::SignalProxy< bool(Gdk::EventMotion&)> | signal_motion_notify_event ()
| Event triggered by user moving pointer. More...
Glib::SignalProxy< bool(Gdk::Event&)> | signal_delete_event ()
Glib::SignalProxy< bool(Gdk::EventKey&)> | signal_key_press_event ()
| Event triggered by a key press will widget has focus. More...
Glib::SignalProxy< bool(Gdk::EventKey&)> | signal_key_release_event ()
| Event triggered by a key release will widget has focus. More...
Glib::SignalProxy< bool(Gdk::EventCrossing&)> | signal_enter_notify_event ()
| Event triggered by pointer entering widget area. More...
Glib::SignalProxy< bool(Gdk::EventCrossing&)> | signal_leave_notify_event ()
| Event triggered by pointer leaving widget area. More...
Glib::SignalProxy< bool(Gdk::EventConfigure&)> | signal_configure_event ()
| Event triggered by a window resizing. More...
Glib::SignalProxy< bool(Gdk::EventFocus&)> | signal_focus_in_event ()
Glib::SignalProxy< bool(Gdk::EventFocus&)> | signal_focus_out_event ()
Glib::SignalProxy< bool(Gdk::Event&)> | signal_map_event ()
Glib::SignalProxy< bool(Gdk::Event&)> | signal_unmap_event ()
Glib::SignalProxy< bool(Gdk::EventProperty&)> | signal_property_notify_event ()
Glib::SignalProxy< bool(Gdk::EventSelection&)> | signal_selection_clear_event ()
Glib::SignalProxy< bool(Gdk::EventSelection&)> | signal_selection_request_event ()
Glib::SignalProxy< bool(Gdk::EventSelection&)> | signal_selection_notify_event ()
Glib::SignalProxy< bool(Gdk::EventProximity&)> | signal_proximity_in_event ()
Glib::SignalProxy< bool(Gdk::EventProximity&)> | signal_proximity_out_event ()
Glib::SignalProxy< bool(Gdk::EventWindowState&)> | signal_window_state_event ()
Glib::SignalProxy< void(SelectionData&, guint, guint)> | signal_selection_get ()
Glib::SignalProxy< void(const SelectionData&, guint)> | signal_selection_received ()
Glib::SignalProxy< void(const Glib::RefPtr< Gdk::DragContext >&)> | signal_drag_begin ()
Glib::SignalProxy< void(const Glib::RefPtr< Gdk::DragContext >&)> | signal_drag_end ()
Glib::SignalProxy< void(const Glib::RefPtr< Gdk::DragContext >&, SelectionData&, guint, guint)> | signal_drag_data_get ()
Glib::SignalProxy< void(const Glib::RefPtr< Gdk::DragContext >&)> | signal_drag_data_delete ()
Glib::SignalProxy< bool(const Glib::RefPtr< Gdk::DragContext >&, DragResult)> | signal_drag_failed ()
Glib::SignalProxy< void(const Glib::RefPtr< Gdk::DragContext >&, guint)> | signal_drag_leave ()
Glib::SignalProxy< bool(const Glib::RefPtr< Gdk::DragContext >&, int, int, guint)> | signal_drag_motion ()
Glib::SignalProxy< bool(const Glib::RefPtr< Gdk::DragContext >&, int, int, guint)> | signal_drag_drop ()
Glib::SignalProxy< void(const Glib::RefPtr< Gdk::DragContext >&, int, int, const SelectionData&, guint, guint)> | signal_drag_data_received ()
Glib::SignalProxy< void(const Glib::RefPtr< Gdk::Screen >&)> | signal_screen_changed ()
Glib::SignalProxy< bool()> | signal_popup_menu ()
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip >&)> | signal_query_tooltip ()
Glib::SignalProxy< bool(Gdk::EventGrabBroken&)> | signal_grab_broken_event ()
Glib::SignalProxy< bool(Gdk::EventTouch&)> | signal_touch_event ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget. More...
Glib::PropertyProxy< Container* > | property_parent ()
| The parent widget of this widget. More...
Glib::PropertyProxy_ReadOnly< Container* > | property_parent () const
| The parent widget of this widget. More...
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input. More...
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input. More...
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy< bool > | property_has_focus ()
| Whether the widget has the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus. More...
Glib::PropertyProxy< bool > | property_is_focus ()
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_focus () const
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse. More...
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse. More...
Glib::PropertyProxy< bool > | property_can_default ()
| Whether the widget can be the default widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_default () const
| Whether the widget can be the default widget. More...
Glib::PropertyProxy< bool > | property_has_default ()
| Whether the widget is the default widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget. More...
Glib::PropertyProxy< bool > | property_receives_default ()
| If TRUE, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| If TRUE, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of Gtk::Widget::signal_query_tooltip() on widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of Gtk::Widget::signal_query_tooltip() on widget. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with the [Pango text markup language][PangoMarkupFormat]. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with the [Pango text markup language][PangoMarkupFormat]. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Window > > | property_window () const
| The widget's window if it is realized, `nullptr` otherwise. More...
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally. More...
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally. More...
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget. More...
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget. More...
Glib::PropertyProxy< int > | property_margin ()
| Sets all four sides' margin at once. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin () const
| Sets all four sides' margin at once. More...
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally. More...
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally. More...
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the Gtk::Widget::property_hexpand() property. More...
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the Gtk::Widget::property_hexpand() property. More...
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically. More...
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically. More...
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the Gtk::Widget::property_vexpand() property. More...
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the Gtk::Widget::property_vexpand() property. More...
Glib::PropertyProxy< bool > | property_expand ()
| Whether to expand in both directions. More...
Glib::PropertyProxy_ReadOnly< bool > | property_expand () const
| Whether to expand in both directions. More...
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget. More...
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree. More...
Public Member Functions inherited from Gtk::Object
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
| ~Object () noexceptoverride
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable&& src) noexcept
Buildable& | operator= (Buildable&& src) noexcept
| ~Buildable () noexceptoverride
GtkBuildable* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuildable* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_name (const Glib::ustring& name)
| Sets the name of the buildable object. More...
Glib::ustring | get_name () const
| Gets the name of the buildable object. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexceptoverride
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Atk::Implementor
| Implementor (Implementor &&src) noexcept
Implementor & | operator= (Implementor &&src) noexcept
| ~Implementor () noexceptoverride
AtkImplementor * | gobj ()
const AtkImplementor * | gobj () const
Glib::RefPtr< Atk::Implementor > | wrap (AtkImplementor *object, bool take_copy=false)
Public Member Functions inherited from Gtk::FileChooser
| FileChooser (FileChooser&& src) noexcept
FileChooser& | operator= (FileChooser&& src) noexcept
| ~FileChooser () noexceptoverride
GtkFileChooser* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkFileChooser* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_action (Action action)
| Sets the type of operation that the chooser is performing; the user interface is adapted to suit the selected action. More...
Action | get_action () const
| Gets the type of operation that the file chooser is performing; see set_action(). More...
void | set_local_only (bool local_only=true)
| Sets whether only local files can be selected in the file selector. More...
bool | get_local_only () const
| Gets whether only local files can be selected in the file selector. More...
void | set_select_multiple (bool select_multiple=true)
| Sets whether multiple files can be selected in the file selector. More...
bool | get_select_multiple () const
| Gets whether multiple files can be selected in the file selector. More...
void | set_show_hidden (bool show_hidden=true)
| Sets whether hidden files and folders are displayed in the file selector. More...
bool | get_show_hidden () const
| Gets whether hidden files and folders are displayed in the file selector. More...
void | set_do_overwrite_confirmation (bool do_overwrite_confirmation=true)
| Sets whether a file chooser in Gtk::FileChooser::Action::SAVE mode will present a confirmation dialog if the user types a file name that already exists. More...
bool | get_do_overwrite_confirmation () const
| Queries whether a file chooser is set to confirm for overwriting when the user types a file name that already exists. More...
void | set_create_folders (bool create_folders=true)
| Sets whether file choser will offer to create new folders. More...
bool | get_create_folders () const
| Gets whether file choser will offer to create new folders. More...
void | set_current_name (const Glib::ustring& name)
| Sets the current name in the file selector, as if entered by the user. More...
Glib::ustring | get_current_name () const
| Gets the current name in the file selector, as entered by the user in the text entry for “Name”. More...
std::string | get_filename () const
| Gets the filename for the currently selected file in the file selector. More...
bool | set_filename (const std::string& filename)
| Sets filename as the current filename for the file chooser, by changing to the file’s parent folder and actually selecting the file in list; all other files will be unselected. More...
bool | select_filename (const std::string& filename)
| Selects a filename. More...
void | unselect_filename (const std::string& filename)
| Unselects a currently selected filename. More...
void | select_all ()
| Selects all the files in the current folder of a file chooser. More...
void | unselect_all ()
| Unselects all the files in the current folder of a file chooser. More...
std::vector< std::string > | get_filenames () const
| Lists all the selected files and subfolders in the current folder of chooser. More...
bool | set_current_folder (const std::string& filename)
| Sets the current folder for chooser from a local filename. More...
std::string | get_current_folder () const
| Gets the current folder of chooser as a local filename. More...
Glib::ustring | get_uri () const
| Gets the URI for the currently selected file in the file selector. More...
bool | set_uri (const Glib::ustring& uri)
| Sets the file referred to by uri as the current file for the file chooser, by changing to the URI’s parent folder and actually selecting the URI in the list. More...
bool | select_uri (const Glib::ustring& uri)
| Selects the file to by uri. More...
void | unselect_uri (const Glib::ustring& uri)
| Unselects the file referred to by uri. More...
std::vector< Glib::ustring > | get_uris () const
| Lists all the selected files and subfolders in the current folder of chooser. More...
bool | set_current_folder_uri (const Glib::ustring& uri)
| Sets the current folder for chooser from an URI. More...
Glib::ustring | get_current_folder_uri () const
| Gets the current folder of chooser as an URI. More...
bool | set_file (const Glib::RefPtr< const Gio::File >& file)
| Sets file as the current filename for the file chooser, by changing to the file’s parent folder and actually selecting the file in list. More...
bool | select_file (const Glib::RefPtr< const Gio::File >& file)
| Selects the file referred to by file. More...
void | unselect_file (const Glib::RefPtr< const Gio::File >& file)
| Unselects the file referred to by file. More...
std::vector< Glib::RefPtr< Gio::File > > | get_files ()
| Lists all the selected files and subfolders in the current folder of chooser as Gio::File. More...
bool | set_current_folder_file (const Glib::RefPtr< const Gio::File >& file)
| Sets the current folder for chooser from a Gio::File. More...
Glib::RefPtr< Gio::File > | get_current_folder_file ()
| Gets the current folder of chooser as Gio::File. More...
Glib::RefPtr< Gio::File > | get_file ()
| Gets the Gio::File for the currently selected file in the file selector. More...
Glib::RefPtr< const Gio::File > | get_file () const
| Gets the Gio::File for the currently selected file in the file selector. More...
void | set_preview_widget (Gtk::Widget& preview_widget)
| Sets an application-supplied widget to use to display a custom preview of the currently selected file. More...
Gtk::Widget* | get_preview_widget ()
| Gets the current preview widget; see set_preview_widget(). More...
const Gtk::Widget* | get_preview_widget () const
| Gets the current preview widget; see set_preview_widget(). More...
void | set_preview_widget_active (bool active=true)
| Sets whether the preview widget set by set_preview_widget() should be shown for the current filename. More...
bool | get_preview_widget_active () const
| Gets whether the preview widget set by set_preview_widget() should be shown for the current filename. More...
void | set_use_preview_label (bool use_label=true)
| Sets whether the file chooser should display a stock label with the name of the file that is being previewed; the default is `true`. More...
bool | get_use_preview_label () const
| Gets whether a stock label should be drawn with the name of the previewed file. More...
std::string | get_preview_filename () const
| Gets the filename that should be previewed in a custom preview widget. More...
Glib::ustring | get_preview_uri () const
| Gets the URI that should be previewed in a custom preview widget. More...
Glib::RefPtr< Gio::File > | get_preview_file ()
| Gets the Gio::File that should be previewed in a custom preview Internal function, see get_preview_uri(). More...
Glib::RefPtr< const Gio::File > | get_preview_file () const
| Gets the Gio::File that should be previewed in a custom preview Internal function, see get_preview_uri(). More...
void | set_extra_widget (Gtk::Widget& extra_widget)
| Sets an application-supplied widget to provide extra options to the user. More...
Gtk::Widget* | get_extra_widget ()
| Gets the current extra widget; see set_extra_widget(). More...
const Gtk::Widget* | get_extra_widget () const
| Gets the current extra widget; see set_extra_widget(). More...
void | add_filter (const Glib::RefPtr< FileFilter >& filter)
| Adds filter to the list of filters that the user can select between. More...
void | remove_filter (const Glib::RefPtr< FileFilter >& filter)
| Removes filter from the list of filters that the user can select between. More...
std::vector< Glib::RefPtr< FileFilter > > | list_filters ()
| Lists the current set of user-selectable filters; see add_filter(), remove_filter(). More...
std::vector< Glib::RefPtr< const FileFilter > > | list_filters () const
| Lists the current set of user-selectable filters; see add_filter(), remove_filter(). More...
void | set_filter (const Glib::RefPtr< FileFilter >& filter)
| Sets the current filter; only the files that pass the filter will be displayed. More...
Glib::RefPtr< FileFilter > | get_filter ()
| Gets the current filter; see set_filter(). More...
Glib::RefPtr< const FileFilter > | get_filter () const
| Gets the current filter; see set_filter(). More...
bool | add_shortcut_folder (const std::string& folder)
| Adds a folder to be displayed with the shortcut folders in a file chooser. More...
bool | remove_shortcut_folder (const std::string& folder)
| Removes a folder from a file chooser’s list of shortcut folders. More...
std::vector< std::string > | list_shortcut_folders () const
| Queries the list of shortcut folders in the file chooser, as set by add_shortcut_folder(). More...
bool | add_shortcut_folder_uri (const Glib::ustring& uri)
| Adds a folder URI to be displayed with the shortcut folders in a file chooser. More...
bool | remove_shortcut_folder_uri (const Glib::ustring& uri)
| Removes a folder URI from a file chooser’s list of shortcut folders. More...
std::vector< Glib::ustring > | list_shortcut_folder_uris () const
| Queries the list of shortcut folders in the file chooser, as set by add_shortcut_folder_uri(). More...
void | add_choice (const Glib::ustring& id, const Glib::ustring& label, const std::vector< Glib::ustring >& options, const std::vector< Glib::ustring >& option_labels)
| Adds a 'choice' to the file chooser. More...
void | add_choice (const Glib::ustring& id, const Glib::ustring& label)
| Adds a boolean 'choice' to the file chooser. More...
void | remove_choice (const Glib::ustring& id)
| Removes a 'choice' that has been added with add_choice(). More...
void | set_choice (const Glib::ustring& id, const Glib::ustring& option)
| Selects an option in a 'choice' that has been added with add_choice(). More...
Glib::ustring | get_choice (const Glib::ustring& id) const
| Gets the currently selected option in the 'choice' with the given ID. More...
Glib::SignalProxy< void()> | signal_current_folder_changed ()
Glib::SignalProxy< void()> | signal_selection_changed ()
Glib::SignalProxy< void()> | signal_update_preview ()
Glib::SignalProxy< void()> | signal_file_activated ()
Glib::SignalProxy< Confirmation()> | signal_confirm_overwrite ()
Glib::PropertyProxy< Action > | property_action ()
| The type of operation that the file selector is performing. More...
Glib::PropertyProxy_ReadOnly< Action > | property_action () const
| The type of operation that the file selector is performing. More...
Glib::PropertyProxy< Glib::RefPtr< FileFilter > > | property_filter ()
| The current filter for selecting which files are displayed. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< FileFilter > > | property_filter () const
| The current filter for selecting which files are displayed. More...
Glib::PropertyProxy< bool > | property_local_only ()
| Whether the selected file(s) should be limited to local file: URLs. More...
Glib::PropertyProxy_ReadOnly< bool > | property_local_only () const
| Whether the selected file(s) should be limited to local file: URLs. More...
Glib::PropertyProxy< Widget* > | property_preview_widget ()
| Application supplied widget for custom previews. More...
Glib::PropertyProxy_ReadOnly< Widget* > | property_preview_widget () const
| Application supplied widget for custom previews. More...
Glib::PropertyProxy< bool > | property_preview_widget_active ()
| Whether the application supplied widget for custom previews should be shown. More...
Glib::PropertyProxy_ReadOnly< bool > | property_preview_widget_active () const
| Whether the application supplied widget for custom previews should be shown. More...
Glib::PropertyProxy< bool > | property_use_preview_label ()
| Whether to display a stock label with the name of the previewed file. More...
Glib::PropertyProxy_ReadOnly< bool > | property_use_preview_label () const
| Whether to display a stock label with the name of the previewed file. More...
Glib::PropertyProxy< Widget* > | property_extra_widget ()
| Application supplied widget for extra options. More...
Glib::PropertyProxy_ReadOnly< Widget* > | property_extra_widget () const
| Application supplied widget for extra options. More...
Glib::PropertyProxy< bool > | property_select_multiple ()
| Whether to allow multiple files to be selected. More...
Glib::PropertyProxy_ReadOnly< bool > | property_select_multiple () const
| Whether to allow multiple files to be selected. More...
Glib::PropertyProxy< bool > | property_show_hidden ()
| Whether the hidden files and folders should be displayed. More...
Glib::PropertyProxy_ReadOnly< bool > | property_show_hidden () const
| Whether the hidden files and folders should be displayed. More...
Glib::PropertyProxy< bool > | property_do_overwrite_confirmation ()
| Whether a file chooser in Gtk::FileChooser::Action::SAVE mode will present an overwrite confirmation dialog if the user selects a file name that already exists. More...
Glib::PropertyProxy_ReadOnly< bool > | property_do_overwrite_confirmation () const
| Whether a file chooser in Gtk::FileChooser::Action::SAVE mode will present an overwrite confirmation dialog if the user selects a file name that already exists. More...
Glib::PropertyProxy< bool > | property_create_folders ()
| Whether a file chooser not in Gtk::FileChooser::Action::OPEN mode will offer the user to create new folders. More...
Glib::PropertyProxy_ReadOnly< bool > | property_create_folders () const
| Whether a file chooser not in Gtk::FileChooser::Action::OPEN mode will offer the user to create new folders. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Dialog
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Window
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static void | set_default_icon_list (const std::vector< Glib::RefPtr< Gdk::Pixbuf > >& list)
| Sets an icon list to be used as fallback for windows that haven't had set_icon_list() called on them to set up a window-specific icon list. More...
static std::vector< Glib::RefPtr< Gdk::Pixbuf > > | get_default_icon_list ()
| Gets the value set by Gtk::Window::set_default_icon_list(). More...
static void | set_default_icon (const Glib::RefPtr< Gdk::Pixbuf >& icon)
| Sets an icon to be used as fallback for windows that haven't had set_icon() called on them from a pixbuf. More...
static void | set_default_icon_name (const Glib::ustring& name)
| Sets an icon to be used as fallback for windows that haven't had set_icon_list() called on them from a named themed icon, see set_icon_name(). More...
static bool | set_default_icon_from_file (const std::string& filename)
| Sets an icon to be used as fallback for windows that haven't had set_icon_list() called on them from a file on disk. More...
static void | set_auto_startup_notification (bool setting=true)
| By default, after showing the first Gtk::Window, GTK+ calls gdk_notify_startup_complete(). More...
static std::vector< Window* > | list_toplevels ()
| Returns a list of all existing toplevel windows. More...
Static Public Member Functions inherited from Gtk::Bin
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Container
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Widget* | get_current_modal_grab ()
| Retrieve the widget which is currently grabbing all events. More...
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction(). More...
static TextDirection | get_default_direction ()
| Obtains the current default reading direction. More...
static Widget* | drag_get_source_widget (const Glib::RefPtr< Gdk::DragContext >& context)
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Atk::Implementor
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
Static Public Member Functions inherited from Gtk::FileChooser
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Gtk::FileChooserDialog* | wrap (GtkFileChooserDialog* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Dialog
Gtk::Dialog* | wrap (GtkDialog* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Window
Gtk::Window* | wrap (GtkWindow* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Bin
Gtk::Bin* | wrap (GtkBin* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Container
Gtk::Container* | wrap (GtkContainer* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Widget
Gtk::Widget* | wrap (GtkWidget* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::FileChooser
Glib::RefPtr< Gtk::FileChooser > | wrap (GtkFileChooser* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Container
using | ForeachSlot = sigc::slot< void(Widget&)>
| For instance, void on_foreach(Gtk::Widget& widget);. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gtk::FileChooser
enum | Action { Action::OPEN, Action::SAVE, Action::SELECT_FOLDER, Action::CREATE_FOLDER }
| Describes whether a Gtk::FileChooser is being used to open existing files or to save to a possibly new file. More...
enum | Confirmation { Confirmation::CONFIRM, Confirmation::ACCEPT_FILENAME, Confirmation::SELECT_AGAIN }
| Used as a return value of handlers for the Gtk::FileChooser::signal_confirm_overwrite() signal of a Gtk::FileChooser. More...
Protected Member Functions inherited from Gtk::Dialog
virtual void | on_response (int response_id)
| This is a default handler for the signal signal_response(). More...
Protected Member Functions inherited from Gtk::Window
void | destroy_ ()
virtual void | on_set_focus (Widget* focus)
| This is a default handler for the signal signal_set_focus(). More...
virtual void | on_keys_changed ()
| This is a default handler for the signal signal_keys_changed(). More...
Protected Member Functions inherited from Gtk::Bin
| Bin ()
| This constructor is protected because only derived classes should be instantiated. More...
Protected Member Functions inherited from Gtk::Container
| Container ()
virtual GType | child_type_vfunc () const
| Implements child_type(). More...
virtual void | forall_vfunc (const ForeachSlot& slot)
| Invokes a callback on all non-internal children of the container. More...
virtual void | set_child_property_vfunc (Widget* child, guint property_id, const Glib::ValueBase& value, GParamSpec* pspec)
| Sets a child property for this container and its child. More...
virtual void | get_child_property_vfunc (const Widget* child, guint property_id, Glib::ValueBase& value, GParamSpec* pspec) const
| Returns a child property for this container and its child. More...
virtual WidgetPath | get_path_for_child_vfunc (const Widget* child) const
| Returns a widget path representing all the widget hierarchy from the toplevel down to and including child. More...
virtual void | on_add (Widget* widget)
| This is a default handler for the signal signal_add(). More...
virtual void | on_remove (Widget* widget)
| This is a default handler for the signal signal_remove(). More...
virtual void | on_check_resize ()
| This is a default handler for the signal signal_check_resize(). More...
Protected Member Functions inherited from Gtk::Widget
virtual void | dispatch_child_properties_changed_vfunc (guint p1, GParamSpec** p2)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int& minimum, int& natural, int& minimum_baseline, int& natural_baseline) const
virtual Glib::RefPtr< Atk::Object > | get_accessible_vfunc ()
virtual void | compute_expand_vfunc (bool& hexpand_p, bool& vexpand_p)
| Widget ()
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget. More...
void | unrealize ()
| This function is only useful in widget implementations. More...
void | draw (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| Draws widget to cr. More...
void | set_realized (bool realized=true)
| Marks the widget as being realized. More...
void | set_has_window (bool has_window=true)
| Specifies whether widget has a Gdk::Window of its own. More...
void | set_window (const Glib::RefPtr< Gdk::Window >& window)
| Sets a widget's window. More...
void | realize_if_needed ()
virtual void | on_show ()
| This is a default handler for the signal signal_show(). More...
virtual void | on_hide ()
| This is a default handler for the signal signal_hide(). More...
virtual void | on_map ()
| This is a default handler for the signal signal_map(). More...
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap(). More...
virtual void | on_realize ()
| This is a default handler for the signal signal_realize(). More...
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize(). More...
virtual void | on_size_allocate (const Allocation& allocation, int baseline, Allocation& out_clip)
| This is a default handler for the signal signal_size_allocate(). More...
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed(). More...
virtual void | on_parent_changed (Widget* previous_parent)
| This is a default handler for the signal signal_parent_changed(). More...
virtual void | on_hierarchy_changed (Widget* previous_toplevel)
| This is a default handler for the signal signal_hierarchy_changed(). More...
virtual void | on_style_updated ()
| This is a default handler for the signal signal_style_updated(). More...
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed(). More...
virtual void | on_grab_notify (bool was_grabbed)
| This is a default handler for the signal signal_grab_notify(). More...
virtual void | on_child_notify (GParamSpec* pspec)
| This is a default handler for the signal signal_child_notify(). More...
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate(). More...
virtual void | on_grab_focus ()
| This is a default handler for the signal signal_grab_focus(). More...
virtual bool | on_focus (DirectionType direction)
| This is a default handler for the signal signal_focus(). More...
virtual bool | on_event (Gdk::Event& gdk_event)
| This is a default handler for the signal signal_event(). More...
virtual bool | on_button_press_event (Gdk::EventButton& button_event)
| This is a default handler for the signal signal_button_press_event(). More...
virtual bool | on_button_release_event (Gdk::EventButton& release_event)
| This is a default handler for the signal signal_button_release_event(). More...
virtual bool | on_scroll_event (Gdk::EventScroll& scroll_event)
| This is a default handler for the signal signal_scroll_event(). More...
virtual bool | on_motion_notify_event (Gdk::EventMotion& motion_event)
| This is a default handler for the signal signal_motion_notify_event(). More...
virtual bool | on_delete_event (Gdk::Event& any_event)
| This is a default handler for the signal signal_delete_event(). More...
virtual bool | on_key_press_event (Gdk::EventKey& key_event)
| This is a default handler for the signal signal_key_press_event(). More...
virtual bool | on_key_release_event (Gdk::EventKey& key_event)
| This is a default handler for the signal signal_key_release_event(). More...
virtual bool | on_enter_notify_event (Gdk::EventCrossing& crossing_event)
| This is a default handler for the signal signal_enter_notify_event(). More...
virtual bool | on_leave_notify_event (Gdk::EventCrossing& crossing_event)
| This is a default handler for the signal signal_leave_notify_event(). More...
virtual bool | on_configure_event (Gdk::EventConfigure& configure_event)
| This is a default handler for the signal signal_configure_event(). More...
virtual bool | on_focus_in_event (Gdk::EventFocus& focus_event)
| This is a default handler for the signal signal_focus_in_event(). More...
virtual bool | on_focus_out_event (Gdk::EventFocus& gdk_event)
| This is a default handler for the signal signal_focus_out_event(). More...
virtual bool | on_map_event (Gdk::Event& any_event)
| This is a default handler for the signal signal_map_event(). More...
virtual bool | on_unmap_event (Gdk::Event& any_event)
| This is a default handler for the signal signal_unmap_event(). More...
virtual bool | on_property_notify_event (Gdk::EventProperty& property_event)
| This is a default handler for the signal signal_property_notify_event(). More...
virtual bool | on_selection_clear_event (Gdk::EventSelection& selection_event)
| This is a default handler for the signal signal_selection_clear_event(). More...
virtual bool | on_selection_request_event (Gdk::EventSelection& selection_event)
| This is a default handler for the signal signal_selection_request_event(). More...
virtual bool | on_selection_notify_event (Gdk::EventSelection& selection_event)
| This is a default handler for the signal signal_selection_notify_event(). More...
virtual bool | on_proximity_in_event (Gdk::EventProximity& proximity_event)
| This is a default handler for the signal signal_proximity_in_event(). More...
virtual bool | on_proximity_out_event (Gdk::EventProximity& proximity_event)
| This is a default handler for the signal signal_proximity_out_event(). More...
virtual bool | on_window_state_event (Gdk::EventWindowState& window_state_event)
| This is a default handler for the signal signal_window_state_event(). More...
virtual void | on_selection_get (SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_selection_get(). More...
virtual void | on_selection_received (const SelectionData& selection_data, guint time)
| This is a default handler for the signal signal_selection_received(). More...
virtual void | on_drag_begin (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_begin(). More...
virtual void | on_drag_end (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_end(). More...
virtual void | on_drag_data_get (const Glib::RefPtr< Gdk::DragContext >& context, SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_get(). More...
virtual void | on_drag_data_delete (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_data_delete(). More...
virtual bool | on_drag_failed (const Glib::RefPtr< Gdk::DragContext >& context, DragResult result)
| This is a default handler for the signal signal_drag_failed(). More...
virtual void | on_drag_leave (const Glib::RefPtr< Gdk::DragContext >& context, guint time)
| This is a default handler for the signal signal_drag_leave(). More...
virtual bool | on_drag_motion (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_motion(). More...
virtual bool | on_drag_drop (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_drop(). More...
virtual void | on_drag_data_received (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, const SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_received(). More...
virtual void | on_screen_changed (const Glib::RefPtr< Gdk::Screen >& previous_screen)
| This is a default handler for the signal signal_screen_changed(). More...
virtual bool | on_popup_menu ()
| This is a default handler for the signal signal_popup_menu(). More...
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip >& tooltip)
| This is a default handler for the signal signal_query_tooltip(). More...
virtual bool | on_grab_broken_event (Gdk::EventGrabBroken& grab_broken_event)
| This is a default handler for the signal signal_grab_broken_event(). More...
virtual bool | on_touch_event (Gdk::EventTouch& touch_event)
| This is a default handler for the signal signal_touch_event(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexceptoverride
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Atk::Implementor
| Implementor ()
virtual Glib::RefPtr< Object > | ref_accessibile_vfunc ()
Protected Member Functions inherited from Gtk::FileChooser
| FileChooser ()
| You should derive from this class to use it. More...

## Detailed Description

Convenient file chooser window.

A FileChooserDialog looks like this:

## Constructor & Destructor Documentation

Gtk::FileChooserDialog::FileChooserDialog | ( | FileChooserDialog&& | src | ) |
| noexcept

Gtk::FileChooserDialog::FileChooserDialog | ( | const FileChooserDialog& |  | ) |
| delete

Gtk::FileChooserDialog::~FileChooserDialog | ( |  | ) |
| overridenoexcept

Gtk::FileChooserDialog::FileChooserDialog | ( | Gtk::Window& | parent,
|  | const Glib::ustring & | title,
|  | Action | action = `Action::OPEN`,
|  | bool | use_header_bar = `false`
| ) |  |

Gtk::FileChooserDialog::FileChooserDialog | ( | const Glib::ustring & | title,
|  | Action | action = `Action::OPEN`,
|  | bool | use_header_bar = `false`
| ) |  |
| explicit

## Member Function Documentation

static GType Gtk::FileChooserDialog::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkFileChooserDialog* Gtk::FileChooserDialog::gobj | ( |  | ) |
| inline

Provides access to the underlying C GtkObject.

const GtkFileChooserDialog* Gtk::FileChooserDialog::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GtkObject.

FileChooserDialog& Gtk::FileChooserDialog::operator= | ( | FileChooserDialog&& | src | ) |
| noexcept

FileChooserDialog& Gtk::FileChooserDialog::operator= | ( | const FileChooserDialog& |  | ) |
| delete

## Friends And Related Function Documentation

Gtk::FileChooserDialog* wrap | ( | GtkFileChooserDialog * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.